{    var   : }
{  A, N, NLC, NUC, R }
Unit AIB1R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, AFB1R_p, ASB1R_p, UTBF10_p;

procedure AIB1R(var A :Array of Real; var AINV :Array of Real;
                N :Integer; NLC :Integer; NUC :Integer;
                var R :Array of Real; var IERR :Integer);
implementation

procedure AIB1R(var A :Array of Real; var AINV :Array of Real;
                N :Integer; NLC :Integer; NUC :Integer;
                var R :Array of Real; var IERR :Integer);
var
I,K,I1,I2 :Integer;
label
_1,_2,_3,_4,_5;
begin
IERR := 0;
AFB1R(A,N,NLC,NUC,R,IERR);
if ( IERR <> 0 ) 
 then goto _4;
K := N*N;
for I:=1 to K do
 begin
_1:
  AINV[I-1] := 0.0;
 end;
I1 := 1;
I2 := N-1;
AINV[0] := 1.0;
for I:=1 to I2 do
 begin
  I1 := I1+N+1;
_2:
  AINV[I1-1] := 1.E0;
 end;
I2 := 1;
while ( I2<=K ) do
 begin
  ASB1R(A,AINV[I2-1],AINV[I2-1],N,NLC,NUC,0,R,IERR);
_3:
  inc(I2,N);
 end;
goto _5;
_4:
UTBF10(IERR,3);
_5:
end;

end.
