Unit ASB1R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, AFB1R_p, UTBF10_p;

procedure ASB1R(var A :Array of Real; var B :Array of Real;
                var X :Array of Real; var N :Integer;
                var NLC :Integer; var NUC :Integer; P :Integer;
                var R :Array of Real; var IERR :Integer);

implementation

procedure ASB1R(var A :Array of Real; var B :Array of Real;
                var X :Array of Real; var N :Integer;
                var NLC :Integer; var NUC :Integer; P :Integer;
                var R :Array of Real; var IERR :Integer);
var
L,J,K,I,K1,IK,KK,NLC1,JBEG :Integer;
P1,B1,B2 :Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10;
begin
IERR := 0;
NLC1 := NLC+1;
if ( P <> 1 ) 
 then goto _1;
AFB1R(A,N,NLC,NUC,R,IERR);
if ( IERR <> 0 ) 
 then goto _9;
_1:
L := NLC;
for J:=1 to N do
 begin
_2:
  X[J-1] := B[J-1];
 end;
for K:=1 to N do
 begin
  I := Trunc( R[(K-1)+(NLC1-1)*N] );
  if ( I = K ) 
   then goto _3;
  P1 := X[K-1];
  X[K-1] := X[I-1];
  X[I-1] := P1;
_3:
  if ( L < N ) 
   then L := L+1;
  K1 := K+1;
  if ( K1 > L ) 
   then goto _5;
  for I:=K1 to L do
   begin
    IK := I-K;
    P1 := R[(K1-1)+(IK-1)*N];
    X[I-1] := X[I-1]-P1*X[K-1];
_4:
   end;
_5:
 end;
JBEG := NUC+NLC;
L := 1;
K1 := N+1;
for I:=1 to N do
 begin
  K := K1-I;
  B1 := A[(K-1)+(1-1)*N];
  P1 := X[K-1];
  if ( L = 1 ) 
   then goto _7;
  for KK:=2 to L do
   begin
    IK := KK+K;
    B2 := A[(K-1)+(KK-1)*N];
    P1 := P1-B2*X[IK-2];
_6:
   end;
_7:
  X[K-1] := P1/B1;
  if ( L <= JBEG ) 
   then L := L+1;
_8:
 end;
goto _10;
_9:
IERR := 129;
UTBF10(IERR,2);
_10:
end;

end.
